
#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;

int eat_loop(int loop, vector<pair<int,int> > &prev, vector<int> &ufset){
	int white = 0, black = 0;
	for(int i=0;i<prev.size()-1;i++){
		if(prev[i].second == -1){
			white++;
		}else{
			int t = ufset.size();
			prev[i].second = t;
			ufset.push_back(t);
			black++;
		}
	}
	return loop * (white+black) - black;
}

int get_root(int a,vector<int> &tidx){
	if(tidx[a] == a) return a;
	return tidx[a] = get_root(tidx[a], tidx);
}
void merge(vector<int> &tidx, int a, int b){
	tidx[get_root(a,tidx)] = get_root(b, tidx);
}

int main(void){
	while(true){
		int w;
		scanf("%d", &w);
		if(w==-1) break;
		int r,dummy;
		scanf("%d %d", &r, &dummy);
		int ans = 0;
		vector<int> ufset;
		vector<pair<int,int> > prev, cur;
		int x = 0;
		int uidx = 0;
		bool s = true;
		prev.push_back(make_pair(0,-1));
		prev.push_back(make_pair(w,-1));
		while(r--){
			int data;
			scanf("%d", &data);
			while(data){
				if(x == 0 && data >= 2*w){
					int loop = data/2/w;
					data -= loop*2*w;
					if(!s)
						ans += eat_loop(loop, prev, ufset);
					continue;
				}
				int tw = min(w - x, min(prev[uidx+1].first-x, data));
				bool is_black = (prev[uidx].second==-1)^s;
				data -= tw;
				if(x == 0 || (is_black^cur[cur.size()-1].second!=-1)){
					if(is_black){
						int t = ufset.size();
						cur.push_back(make_pair(x,t));
						ufset.push_back(t);
					}else{
						cur.push_back(make_pair(x,-1));
					}
				}
				if(is_black && prev[uidx].second != -1)
					merge(ufset, cur[cur.size()-1].second, prev[uidx].second);
				x += tw;
				if(x == prev[uidx+1].first)
					uidx++;
				if(x == w){
					x = 0;
					uidx = 0;
					cur.push_back(make_pair(w,-1));
					prev.swap(cur);
					cur.clear();
				}
			}
			s = !s;
		}
		for(int i=0;i<ufset.size();i++)
			if(ufset[i] == i)
				ans++;
		printf("%d\n",ans);
	}
	return 0;
}
